local glfw = require 'glfw'

print('glfwInit', glfw.Init())
glfw.OpenWindowHint(glfw.OPENGL_VERSION_MAJOR, 3)
glfw.OpenWindowHint(glfw.OPENGL_VERSION_MINOR, 1)
glfw.OpenWindowHint(glfw.OPENGL_FORWARD_COMPAT, glfw.FALSE)
print('glfwOpenWindow',
    glfw.OpenWindow(100, 100, 8, 8, 8, 8, 24, 0, glfw.WINDOW))
print("opengl version " ..
  glfw.GetWindowParam(glfw.OPENGL_VERSION_MAJOR) .. "." ..
  glfw.GetWindowParam(glfw.OPENGL_VERSION_MINOR))

local GL_VERTEX_SHADER = 0x8b31

print()

do ----------------------------------------------------------------------------
  print('this doesn\'t work')

  local ffi = require 'ffi'
  local libgl = ffi.load('GL')

  ffi.cdef[[
  typedef unsigned int GLenum;
  typedef unsigned char GLubyte;
  typedef unsigned int GLuint;

  extern void (*glXGetProcAddress(const GLubyte *procname))( void );

  typedef GLuint (*PFNGLCREATESHADERPROC) (GLenum type);
  ]]

  local glCreateShader =
    ffi.cast('PFNGLCREATESHADERPROC', libgl.glXGetProcAddress('glCreateShader'))
  print('glCreateShader', glCreateShader(GL_VERTEX_SHADER))
  print()
end

do ----------------------------------------------------------------------------
  print('this does')
  local gl = require 'gl'
  print('glCreateShader', gl.glCreateShader(GL_VERTEX_SHADER))
end
